<img src="https://cdn.siter.io/assets/ast_kSk43nA4wqPNF8sfBtWdJsL1Z/85cc5c6c-43dd-44a2-90cf-2ae17cd6a25d.svg" alt="Apphud"/>

## Apphud Flutter SDK

Official Apphud Flutter SDK is a lightweight open-source library to manage auto-renewable subscriptions and other in-app purchases in your iOS/Android app. No backend required.

Visit our website for details: https://apphud.com

## Features

👍 Integrating subscriptions using our SDK is very easy.<br/>Apphud takes care of a subscription purchase process. Integrate SDK in just a few lines of code.

🧾 App Store receipts validation.<br/>Apphud validates and periodically refreshes App Store receipts to give you real-time data.

🧾 Google Play purchases validation.<br/>Apphud validates and periodically refreshes Google Play purchases to give you real-time data.

🕗 View subscription details and transactions history.<br/>Get expiration date, autorenew status in our SDK.

🕗 View non-renewing purchase details and transactions history.

🔍 Determine for trial, introductory and promotional offer eligibility in your iOS app using our SDK. 

🔔 Receive a real-time notification when a user gets billed.<br/>We will send you a message to Slack and Telegram immediately when a user gets billed or started trial.

📊 View key in-app purchases metrics in our [dashboard](https://docs.apphud.com/analyze/dashboard) and [charts](https://docs.apphud.com/analyze/charts).

🔌 Integrations. Are available on all plans. Send subscription renewal events to other mobile analytics.<br/>Apphud reduces pain in sending all subscription events to external mobile analytics: Amplitude, Mixpanel, AppsFlyer, etc.

🎨 Create subscription purchase screens without coding in our visual web editor.<br/>You don't need to develop purchase screens. Just pick a template and modify it. So easy!

✔ Promotional [subscription offers](https://docs.apphud.com/getting-started/promo-offers) support.<br/>Use Apphud to easily give a discount for existing and lapsed customers. No backend required.

💱 User local currency real-time conversion.

🏆 Increase iOS app revenue using our [Rules](https://docs.apphud.com/rules-and-screens/rules).<br/>Apphud will automatically offer a promotional discount based subscription events.

🕵️ Subscription cancellation insights tool.<br/>Understand why you customers cancel a subscription to make right product decisions.

💸 Handle billing grace period and billing issues.<br/>Apphud will automatically ask a user to update his billing details in case of billing issue during renewal.

👏 Great [documentation](https://docs.apphud.com/).

🏃‍♂️ Fast [support](https://apphud.com/contacts ). We are online.

## Installation

Please feel free to read our [SDK Integration Guide](https://docs.apphud.com/getting-started/sdk-integration).

## Having troubles?

If you have any questions or troubles with SDK integration feel free to contact us. We are online.

https://apphud.com/contacts

*Like Apphud? Place a star at the top 😊*

## License

MIT
